//+------------------------------------------------------------------+
//|                                                        Yurik.mq4 |
//|                      Copyright  2009, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2009, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"
#include <stderror.mqh>
#include <stdlib.mqh>

extern string comm1=" ";
extern double Step=25;
extern int StepMode=0;
//  StepMode = 0,        step
//  StepMode = 1,    
extern double UseDepo=100; //    ( ),     
extern double nSymbols=1; //  ,       
extern double ProfFactor=10;
extern double Mult=1.5;
extern double bLot=0.1;
extern double sLot=0.1; 
extern double TS=25; // TrailingStop    
extern double Magic=555;
extern string comm2=" ";
extern double per_K=200;
extern double per_D=20;
extern double slow=20;
extern double bZone=50;
extern double sZone=50;
extern int Slip=0;	//   
extern bool bInfo=true;	//       

double maxLot, Lot, lastLot, sumLot, MaxMargin;
double op, tp, sl, profit;
int ticket; 
int Ticket[2000];	//  
int err;
double FreezLvl, StopLvl, Spread, OpenLvl, Pnt, _Point, _Digits, _Bid, _Ask, LotDigit, MinLot;
string st;
//------------------------------------------------------------	start
int start()
{
	string smb=Symbol();
	int tf=Period();
	//----
	int n, i;
	double mStoch, sStoch;
	
	RefreshParam(smb); //    
	if (MinLot==0.01) { LotDigit=2; maxLot=MarketInfo(smb, MODE_MAXLOT); }
	if (MinLot==0.1) { LotDigit=1; maxLot=((AccountBalance()/2)/1000); }

	mStoch=iStochastic(smb, tf, per_K, per_D, slow, MODE_LWMA, 1, MODE_MAIN, 1);
	sStoch=iStochastic(smb, tf, per_K, per_D, slow, MODE_LWMA, 1, MODE_SIGNAL, 1);
	st="";
	
	//  
	profit=0; MaxMargin=AccountBalance()*UseDepo/(100*nSymbols);
	n=CreateTicketArray(OP_BUY, Magic, smb); //     
	if(n<=0 && AccountMargin()<MaxMargin) //   
	{
		if (mStoch>sStoch && sStoch>bZone) //    
		{
			ticket=OrderSend(smb, OP_BUY, bLot, _Ask, Slip, 0, 0, "", Magic, 0, Blue);
			if (ticket<=0) ErrorHandle(GetLastError(), -1, Magic, "OrderSend Buy 1");
		}	
	}
	MaxMargin=AccountBalance()*UseDepo/(100*nSymbols);
	n=CreateTicketArray(OP_BUY, Magic, smb); //     
	if (n>0 && AccountMargin()<MaxMargin) //    
	{
		sumLot=0;
		for (i=0; i<n; i++) { OrderSelect(Ticket[i], SELECT_BY_TICKET); sumLot+=OrderLots(); } //   
		op=OrderOpenPrice(); Lot=NormalizeDouble((OrderLots()*Mult), LotDigit); //     
		if (sumLot+Lot<maxLot)
		{ 
			Lot=NormalizeDouble(Mult*bLot*n, LotDigit);
			if ((StepMode==0 && _Ask<=op-Step*_Point) || (StepMode==1 && _Ask<=op-(Step+2*n-2)*_Point))
			{
				ticket=OrderSend(smb, OP_BUY, Lot, _Ask, Slip, 0, 0, "", Magic, 0, Blue);
				if (ticket<=0) ErrorHandle(GetLastError(), -1, Magic, "OrderSend Buy 2");
			}
		}
	}
	//  
	n=CreateTicketArray(OP_BUY, Magic, smb);  //     
	if (n>0) 
	{	
		for (i=0; i<n; i++) { OrderSelect(Ticket[i], SELECT_BY_TICKET); profit+=OrderProfit(); } //   
		op=OrderOpenPrice(); sl=OrderStopLoss(); //   
		tp=n*ProfFactor*_Point+op; //      
		if (profit>0 && _Bid>=tp) CloseOrders(OP_BUY, Magic, smb); //   ,      
		else if (n>1 && TS>0) //      
		{
			if (_Bid-op>TS*_Point && (sl<_Bid-TS*_Point || sl==0))
			{
				OrderModify(Ticket[n-1], op, NormalizeDouble(_Bid-TS*_Point, _Digits), 0, 0, Gold);
				return(0);
			}
		}
	}
	st=st+"\n Totalbuy="+CountOrders(OP_BUY, Magic, smb)+" Lot="+sumLot+" Profitbuy="+profit; //  	

	//----------------------------------------------------------------------

	//   
	profit=0; 
	MaxMargin=AccountBalance()*UseDepo/(100*nSymbols);
	n=CreateTicketArray(OP_SELL, Magic, smb);
	if(n<=0 && AccountMargin()<MaxMargin) //   
	{
		if (mStoch<sStoch && sStoch<sZone) //     
			OrderSend(smb, OP_SELL, sLot, _Bid, Slip, 0, 0, "", Magic, 0,Red); 
	}
	
	MaxMargin=AccountBalance()*UseDepo/(100*nSymbols);
	n=CreateTicketArray(OP_SELL, Magic, smb);
	if (n>0 && AccountMargin()<MaxMargin) //    
	{
		sumLot=0;
		for (i=0; i<n; i++) { OrderSelect(Ticket[i], SELECT_BY_TICKET); sumLot+=OrderLots(); }
		op=OrderOpenPrice(); Lot=NormalizeDouble((OrderLots()*Mult), LotDigit); //     
		if (sumLot+Lot<maxLot)
		{
			Lot=NormalizeDouble(Mult*sLot*n, LotDigit);
			if ((StepMode==0 && _Bid>=op+Step*_Point) || (StepMode==1 && _Bid>=op+(Step+2*n-2)*_Point))
				OrderSend(smb, OP_SELL, Lot, _Bid, Slip, 0, 0, "", Magic, 0, Red);
		}
	}
	//  
	n=CreateTicketArray(OP_SELL, Magic, smb);
	if (n>0) 
	{	
		for (i=0; i<n; i++) { OrderSelect(Ticket[i], SELECT_BY_TICKET); profit+=OrderProfit(); }
		op=OrderOpenPrice(); sl=OrderStopLoss(); //   
		tp=op-n*ProfFactor*_Point;
		if (profit>0 && _Ask<=tp) CloseOrders(OP_SELL, Magic, smb); 
		else if (n>1 && TS>0)
		{
			if (op-_Ask>TS*_Point && (sl>_Ask+TS*_Point || sl==0)) 
			{
				OrderModify(Ticket[n-1], op, NormalizeDouble(_Ask+TS*_Point, _Digits), 0, 0, Gold);
				return(0);
			}
		}
	}
	st=st+"\n TotalSell="+CountOrders(OP_SELL, Magic, smb)+" Lot="+sumLot+" ProfitSell="+profit; //  


	st="FreeMargin="+NormalizeDouble(AccountFreeMargin(), 0)+" Balance="+NormalizeDouble(AccountBalance(), 0)+" maxLot="+NormalizeDouble(maxLot, LotDigit)+"\n"+st;
	Comment(st); //  	
	return(0);
}

//---------------------------------------------------------------   CreateTicketArray
int CreateTicketArray(int dir, int SysID, string smb)
{
	int total=OrdersTotal(), i, c=0; if (total<=0) return (0);
	for(i=0;i<total;i++) 
	{ 
		OrderSelect(i, SELECT_BY_POS); 
		if ((OrderType()==dir) && (OrderMagicNumber()==SysID) && (OrderSymbol()==smb || smb=="")) 
		{ Ticket[c] = OrderTicket(); c++; } 
	}
	return (c);
}
//---------------------------------------------------------------   CountOrders
int CountOrders(int dir, int SysID, string smb)
{
  int total=OrdersTotal(), i, c=0; if (total<=0) return (0);
	for(i=0;i<total;i++) 
	{ 
		OrderSelect(i, SELECT_BY_POS);	
		if (OrderType()==dir && OrderMagicNumber()==SysID && (OrderSymbol()==smb || smb=="")) c=c+1;
	}
	return (c);
}
//---------------------------------------------------------------   CloseOrders
bool CloseOrders(int dir, int SysID, string smb)
{
  //   
	int i, total = OrdersTotal();	if (total<=0) return(true);
	if (dir==OP_BUY)
	{
		total = CreateTicketArray(OP_BUY, SysID, smb); 	if (total<=0) return(true); //
		for (i=0; i<total; i++)	
		{	
			OrderSelect(Ticket[i], SELECT_BY_TICKET);	
			if (!OrderClose(Ticket[i], OrderLots(), _Bid, Slip)) { ErrorHandle(GetLastError(), Ticket[i], SysID, "OrderClose"); return(false); }
		}
	}
	if (dir==OP_SELL)
	{
		total=CreateTicketArray(OP_SELL, SysID, smb); 	if (total<=0) return(true); //
		for (i=0; i<total; i++)	
		{	
			OrderSelect(Ticket[i], SELECT_BY_TICKET);	
			if (!OrderClose(Ticket[i], OrderLots(), _Ask, Slip)) { ErrorHandle(GetLastError(), Ticket[i], SysID, "OrderClose"); return(false); }
		}
	}
	if (dir==OP_BUYLIMIT || dir==OP_SELLLIMIT || dir==OP_BUYSTOP || dir==OP_SELLSTOP)
	{
		total=CreateTicketArray(dir, SysID, smb); 	if (total<=0) return(true); //
		for (i=0; i<total; i++)	
			if (!OrderDelete(Ticket[i])) { ErrorHandle(GetLastError(), Ticket[i], SysID, "OrderDelete"); return(false); }
	}
	return(true);
}
//---------------------------------------------------------------   RefreshParam
void RefreshParam(string smb)
{
	RefreshRates();
	_Digits=MarketInfo(smb, MODE_DIGITS);
	Pnt=1; if (_Digits==5 || _Digits==3) Pnt=10;
	_Point=MarketInfo(smb, MODE_POINT);
	_Bid=NormalizeDouble(MarketInfo(smb, MODE_BID), _Digits);
	_Ask=NormalizeDouble(MarketInfo(smb, MODE_ASK), _Digits);
	FreezLvl=MarketInfo(smb, MODE_FREEZELEVEL)*_Point;
	StopLvl=MarketInfo(smb, MODE_STOPLEVEL)*_Point;
	Spread=MarketInfo(smb, MODE_SPREAD)*_Point;
	MinLot=MarketInfo(smb, MODE_MINLOT);
}
//---------------------------------------------------------------   ErrorHandle
void ErrorHandle(int err, int OrderID, int SysID, string str)
{
	if (bInfo) Print("-- ("+err+"): "+ErrorDescription(err)+" -- Magic: "+SysID+" -- : #"+OrderID+" -- "+str); 
	switch (err)
	{
		case ERR_SERVER_BUSY: //4    
		case ERR_NO_CONNECTION: //6      
		case ERR_TOO_FREQUENT_REQUESTS: //8    
		case ERR_BROKER_BUSY: //137   
		case ERR_TOO_MANY_REQUESTS: //141    
		case ERR_TRADE_CONTEXT_BUSY: //146    
			Sleep(2000); //  2 
			break;
		
		case ERR_PRICE_CHANGED: //135   
		case ERR_REQUOTE: //138   
			RefreshRates(); //   
			break;
	}
}
/*
//---------------------------------------------------------------   GetMaxOrder
int GetMaxOrder(int dir, int SysID, string smb)
{
	double d=0; int k=0;
	for (int i=0; i<OrdersTotal(); i++)
	{
		OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
		if (OrderType()==dir && OrderMagicNumber()==SysID && (OrderSymbol()==smb || smb=="") && OrderLots()>d) 
			{ d=OrderLots(); k=i; }
	}
	return(k);
}
//---------------------------------------------------------------   GetMinOrder
int GetMinOrder(int dir, int SysID, string smb)
{
	double d=0.0; int k=0;
	for (int i=0; i<OrdersTotal(); i++)
	{
		OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
		if (OrderType()==dir && OrderMagicNumber()==SysID && (OrderSymbol()==smb || smb=="") && (OrderLots()<d || d==0.0)) 
			{ d=OrderLots(); k=i; }
	}
	return(k);
}
*/